BulkyWeb/Areas/Admin/Controllers/BookProductController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
// using Microsoft.AspNetCore.Authorization;
using Bulky.Models;
// using Bulky.Utils;
using Bulky.Models.ViewModels;
using Bulky.DataAccess.Repository.IRepository;

namespace BulkyWeb.Areas.Admin.Controllers
{
    [Area("Admin")]
    // [Authorize(Roles = SD.Role_Admin)]
    public class BookProductController : Controller
    {
        private readonly IUnitOfWork _unitOfWork;
        private readonly IWebHostEnvironment _webHostEnvironment;

        public BookProductController(IUnitOfWork unitOfWork, IWebHostEnvironment webHostEnvironment)
        {
            _unitOfWork = unitOfWork;
            _webHostEnvironment = webHostEnvironment;
        }

        public IActionResult Upsert(int? id)
        {
            ProductVM productVM = new()
            {
                Product = new BookProduct(),
                CategoryList = _unitOfWork.Category.GetAll().Select(
                    u => new SelectListItem {
                        Text = u.Name,
                        Value = u.Id.ToString()
                    }
                )
            };

            if (id == null || id == 0)
            {
                //Create
                return View(productVM);

            }
            else
            {
                //Update
                productVM.Product = _unitOfWork.BookProduct.Get(b => b.Id == id, includeProperties : "ProductImages");
                return View(productVM);
            }

        }

        [HttpPost]
        public IActionResult Upsert(ProductVM BookVM, List<IFormFile>? files)
        {
            if(ModelState.IsValid)
            {
                if (BookVM.Product.Id == 0)
                {
                    _unitOfWork.BookProduct.Add(BookVM.Product);
                }
                else
                {
                    _unitOfWork.BookProduct.Update(BookVM.Product);
                }

                _unitOfWork.Save();

                string wwwRootPath = _webHostEnvironment.WebRootPath;

                if (files is not null)
                {
                    foreach (IFormFile img_file in files)
                    {
                        string filename = Guid.NewGuid().ToString() + Path.GetExtension(img_file.FileName);
                        string productPath = @"images/product-" + BookVM.Product.Id;
                        string finalPath = Path.Combine(wwwRootPath, productPath);

                        if (!Directory.Exists(finalPath))
                            Directory.CreateDirectory(finalPath);


                        using (var fileStream = new FileStream(Path.Combine(finalPath, filename), FileMode.Create))
                        {
                            img_file.CopyTo(fileStream);
                        }

                        ProductImage productImage = new ()
                        {
                            ImageUrl=@"/" + productPath + @"/" + filename,
                            ProductId = BookVM.Product.Id,
                        };

                        if ( BookVM.Product.ProductImages is null )
                            BookVM.Product.ProductImages = new List<ProductImage>();

                        BookVM.Product.ProductImages.Add(productImage);
                    }

                    _unitOfWork.BookProduct.Update(BookVM.Product);
                    _unitOfWork.Save();
                }

                TempData["success"] = "Product created/updated successfully";
                return RedirectToAction("Index");
            }
            else
            {                
                BookVM.CategoryList = _unitOfWork.Category.GetAll().Select(
                    u => new SelectListItem {
                        Text = u.Name,
                        Value = u.Id.ToString()
                    }
                );
            }
            return View(BookVM);
        }

        public IActionResult Index()
        {
            List<BookProduct> O_BookProductList = _unitOfWork.BookProduct.GetAll(includeProperties: "Category").ToList();
            
            return View(O_BookProductList.OrderBy(b => b.Id));
        }

        public IActionResult DeleteImage(int imageId)
        {
            var imageToBeDeleted = _unitOfWork.ProductImage.Get(img => img.Id == imageId);

            string wwwRootPath = _webHostEnvironment.WebRootPath;

            if ( imageToBeDeleted is not null )
            {
                if (!string.IsNullOrEmpty(imageToBeDeleted.ImageUrl))
                {

                    var oldImagePath = wwwRootPath + imageToBeDeleted.ImageUrl;

                    if (System.IO.File.Exists(oldImagePath))
                    {
                        System.IO.File.Delete(oldImagePath);
                    }
                    _unitOfWork.ProductImage.Remove(imageToBeDeleted);

                }

                _unitOfWork.Save();
            }

            TempData["success"] = "Deleted successfully";
            return RedirectToAction(nameof(Upsert), new { id = imageToBeDeleted?.ProductId  });
        }

        #region API CALLS

        [HttpGet]
        public IActionResult GetAll()
        {
            List<BookProduct> O_BookList = _unitOfWork.BookProduct.GetAll(includeProperties: "Category").ToList();
            return Json(
                new {
                    data = O_BookList
                }
            );
        }

        [HttpDelete]
        public IActionResult Delete(int? id)
        {
            if (id is not null)
            {
                BookProduct bookToBeDeleted = _unitOfWork.BookProduct.Get(b => b.Id == id);

                if ( bookToBeDeleted is null )
                {
                    return Json(
                        new {
                            success = false,
                            message = "Error while deleting"
                        });
                }

                string productPath = @"images/product-" + id;
                string finalPath = Path.Combine(_webHostEnvironment.WebRootPath, productPath);

                        if (Directory.Exists(finalPath))
                        {
                            string[] filePaths = Directory.GetFiles(finalPath);

                            foreach (string filePath in filePaths) {
                                System.IO.File.Delete(filePath);
                            }

                            Directory.Delete(finalPath);
                        }


                _unitOfWork.BookProduct.Remove(bookToBeDeleted);
                _unitOfWork.Save();
                return Json(
                    new {
                        success = true,
                        message = "Book has been deleted successfully"
                    });

            }
            return Json(
                    new {
                        success = false,
                        message = "You have not provide a valid book product id"
                    });
        }

        #endregion

    }
}

BulkyWeb/Areas/Admin/Views/BookProduct/Index.cshtml
<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                <h2 class="text-white py-2">List of Products</h2>
            </div>
        </div>
    </div>

    <div class="card-body p-4">
        <div class="row pb-3">
            <div class="col-12 text-end">
                <a asp-controller="BookProduct" asp-action="Upsert" class="btn btn-primary">
                    Add new Book<span>&nbsp;&nbsp;</span><i class="bi bi-plus-square-dotted"></i>
                </a>
            </div>
        </div>
    <table id="tblData" class="table table-bordered table-striped p-2" style="width:100%">
        <thead>
            <tr>
                <th>
                    <h5><b>Book Title</b></h5>
                </th>
                <th>
                    <h5><b>ISBN</b></h5>
                </th>
                <th>
                    <h5><b>Price</b></h5>
                </th>
                <th>
                    <h5><b>Author</b></h5>
                </th>
                <th>
                    <h5><b>Category</b></h5>
                </th>
                <th>
                    <h5><b>Actions</b></h5>
                </th>
            </tr>
        </thead>

    </table>
</div>

@section Scripts {
    <script src="~/js/product.js"></script>
}

BulkyWeb/Areas/Admin/Views/BookProduct/Upsert.cshtml
@model ProductVM

@{
    /* var imagePath=Model.Product.ImageUrl; */
}
<div class="card shadow border-0 mt-4">
    <div class="card-header bg-secondary bg-gradient ml-0 py-3">
        <div class="row">
            <div class="col-12 text-center">
                @if(@Model.Product.Id != 0)
                {
                    <h2 class="text-white py-2">Update Product</h2>
                }
                else
                {
                    <h2 class="text-white py-2">Create Product</h2>
                }
            </div>
        </div>
    </div>
    <div class="card-body p-4">
        <form method="post" class="row" enctype="multipart/form-data">
            <input asp-for="Product.Id" hidden />
            <!-- <input asp-for="Model.Product.ImageUrl" hidden /> -->
            <div class="row">
                <div class="col-10">
                    <div class="border p-3">
                        <div class="row pb-2">
                            <!-- <hr/> -->
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.Title" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.Title" class="ms-2"></label>
                            <span asp-validation-for="Product.Title" class="text-danger"></span>
                        </div>
                        <div class="py-2 col-12">
                            <label asp-for="Product.Description" class="ms-2 text-muted"></label>
                            <textarea asp-for="Product.Description" class="form-control border-0 shadow"></textarea>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.ISBN" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.ISBN" class="ms-2"></label>
                            <span asp-validation-for="Product.ISBN" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.Author" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.Author" class="ms-2"></label>
                            <span asp-validation-for="Product.Author" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.ListPrice" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.ListPrice" class="ms-2"></label>
                            <span asp-validation-for="Product.ListPrice" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.Price" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.Price" class="ms-2"></label>
                            <span asp-validation-for="Product.Price" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.Price50" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.Price50" class="ms-2"></label>
                            <span asp-validation-for="Product.Price50" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input asp-for="Product.Price100" class="form-control border-0 shadow"></input>
                            <label asp-for="Product.Price100" class="ms-2"></label>
                            <span asp-validation-for="Product.Price100" class="text-danger"></span>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <input type="file" name="files" class="form-control border-0 shadow" multiple></input>
                            <label asp-for="@Model.Product.ProductImages" class="ms-2"></label>
                        </div>
                        <div class="form-floating py-2 col-12">
                            <select asp-for="@Model.Product.CategoryId" asp-items="@Model.CategoryList" class="form-select border-0 shadow">
                                <option disabled selected>--Select Category--</option>
                            </select>
                            <label asp-for="Product.CategoryId" class="ms-2"></label>
                            <span asp-validation-for="Product.CategoryId" class="text-danger"></span>
                        </div>
                        <div class="row pt-2">
                            <div class="col-md-6 col-md-3">
                                @if (@Model.Product.Id != 0 )
                                {
                                    <button type="submit" class="btn btn-primary" style="width:120px">Update</button>
                                }
                                else
                                {
                                    <button type="submit" class="btn btn-primary" style="width:120px">Create</button>
                                }
                                    <a asp-controller="BookProduct" asp-action="Index" class="btn btn-secondary" >Back to Book List</a>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-2">
                    @if (Model.Product.ProductImages is not null)
                    {
                        @foreach (var image in Model.Product.ProductImages)
                        {
                            <div class="border p-1 m-2 text-center">
                                <img src="@image.ImageUrl" width="100%"
                                     style="border-radius:5px; border:1px solid #bbb9b9" />
                                     <a asp-action="DeleteImage" class="btn btn-danger" asp-route-imageId="@image.Id">
                                    <i class="bi bi-trash-fill"></i> Delete
                                     </a>
                            </div>
                        }

                    }
                    <!-- <img src="~/imagePath" width="100%" style="border-radius:5px; border:1px solid #bbb9b9"/> -->
                </div>
            </div>

        </form>
    </div>
</div>


@section scripts {
    @{
        <partial name="_ValidationScriptsPartial" />
    }
    <script>
    tinymce.init({
      selector: 'textarea',
      plugins: 'anchor autolink charmap codesample lists table visualblocks wordcount checklist mediaembed casechange export formatpainter pageembed permanentpen powerpaste advtable advcode editimage tableofcontents footnotes mergetags autocorrect inlinecss',
      toolbar: 'undo redo | blocks fontfamily fontsize | bold italic underline strikethrough | align lineheight | checklist numlist bullist indent outdent',
    });
  </script>

}